//       _________ __                 __
//      /   _____//  |_____________ _/  |______     ____  __ __  ______
//      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
//      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ |
//     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
//             \/                  \/          \//_____/            \/
//  ______________________                           ______________________
//                        T H E   W A R   B E G I N S
//         Stratagus - A free fantasy real time strategy game engine
//
//      (c) Copyright 2019-2020 by Andrettin
//
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; only version 2 of the License.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//      02111-1307, USA.
//

#include "util/random.h"

#include <boost/random.hpp>

namespace wyrmgus {

int random::generate_in_range(const int min_value, const int max_value)
{
	//we have to use the Boost number distribution here since it is portable (has the same result with different compilers), which the standard library's isn't
	boost::random::uniform_int_distribution<int> distribution(min_value, max_value);
	int result = distribution(this->engine);
	return result;
}

int random::generate_in_range_async(const int min_value, const int max_value)
{
	boost::random::uniform_int_distribution<int> distribution(min_value, max_value);
	int result = distribution(this->async_engine);
	return result;
}

}
